#
# Imports
#
import sys
from coopr.pyomo import *

#
# Setup
#

model = Model()

# ***********************************

model.PROD = Set()

model.ACT = Set()

# ***********************************

model.cost = Param(model.ACT, within=PositiveReals)

model.demand = Param(model.PROD, within=NonNegativeReals)

model.io = Param(model.PROD, model.ACT, within=NonNegativeReals)

model.level_min = Param(model.ACT, within=NonNegativeReals)

model.level_max = Param(model.ACT, within=NonNegativeReals)

# ***********************************

def Level_bounds(i, model):
  return (model.level_min[i], model.level_max[i])
model.Level = Var(model.ACT, bounds=Level_bounds)

# ***********************************

def Total_Cost_rule(model):
    expr=0
    for j in model.ACT:
      expr += model.cost[j]*model.Level[j]
    return expr
model.Total_Cost = Objective(rule=Total_Cost_rule)

def Demand_rule(i, model):
    expr = 0
    for j in model.ACT:
      expr += model.io[i,j] * model.Level[j]
    expr = expr > model.demand[i]
    return expr
model.Demand = Constraint(model.PROD, rule=Demand_rule)

